'
'install.vbs
'Script for adding WebKnight in IIS on a destination host in a destination folder
'
Option Explicit

Dim HostName
Dim HostNameI
Dim Filters
Dim Filter
Dim LoadOrder
Dim FilterName
Dim FilterPath
Dim FilterPathI
Dim FilterDLLName
Dim FilterDesc
Dim tmp

HostNameI = "LocalHost"
FilterPathI = "C:\Program Files\AQTRONIX WebKnight\"
FilterName = "WebKnight"
FilterDLLName = "WebKnight.dll"
FilterDesc = "Filter for securing IIS"

'uncomment the two lines below for unattended setup
'HostName = HostNameI
'FilterPath = FilterPathI

'ask for hostname if we don't have one
If HostName = "" Then
	HostName = InputBox("Specify the IIS host where you want " & FilterName & " to be installed","Hostname required",HostNameI)
End If
If HostName <> "" Then 'user did not cancel?
	If FilterPath = "" Then 'ask for path to install the filter into
		FilterPath = InputBox("Specify a path on " & HostName & " where you want " & FilterName & " to be installed. This has to be an absolute path (with a local drive letter on that host, no UNC allowed here!)","Path required", FilterPathI)
	End If
	If FilterPath <> "" Then 'user did not cancel?
		If Left(FilterPath,1)="\" Then	'no UNC paths!
			MsgBox "UNC paths not allowed, told you so!",,FilterName
		Else
			'add trailing slash if not there
			If Right(FilterPath,1)<>"\" And Right(FilterPath,1)<>"/" Then
				FilterPath = FilterPath & "\"
			End If

			'get list of filters on the host
			Set Filters = GetObject("IIS://" & HostName & "/W3SVC/Filters")
			LoadOrder = Filters.FilterLoadOrder

			If InStr(1,LoadOrder,FilterName)>0 Then	'filter already installed?
				MsgBox FilterName & " is already installed on " & Hostname,,FilterName
			Else
				'copy files to host
				Dim uncpath: Dim src
				If LCase(HostName)="localhost" Then 'no unc required for local install
					uncpath = FilterPath
				Else
					uncpath = "\\" & HostName & "\" & Replace(FilterPath,":","$")
				End If

				Dim Cancel: Cancel = False
				Dim fso
				Set fso = CreateObject("Scripting.FileSystemObject")
				src = fso.GetAbsolutePathName(FilterDLLName)
				src = Left(src,Len(src)-Len(filterDLLName)) & "*.*"

				On Error Resume Next
				fso.CreateFolder uncpath
				Err.Clear
				fso.CopyFile src,uncpath,False
				If Err Then
					If MsgBox("Error copying the files to " & uncpath & ". If you know the error (access denied, default shares don't exist,...). You can continue setup and copy all the files manually. Click Yes to continue setup, No to cancel the installation." & vbCRLF & vbCRLF & "The specified error was: " & err.number & ": " & err.Description ,vbYesNo,FilterName)=vbNo Then
						Cancel = True
					End If
				End If
				On Error Goto 0

				'register filter in IIS metabase
				If Not Cancel Then
					'set filter to be loaded first (high security) but after sspifilt & Compression
					If LoadOrder <> "" Then
						LoadOrder = "," & LoadOrder
					End If
					LoadOrder = FilterName & LoadOrder
					If InStr(1,LoadOrder,"Compression")>0 Then
						LoadOrder = Replace(LoadOrder,"Compression","")
						LoadOrder = Replace(LoadOrder,",,",",")
						LoadOrder = "Compression," & LoadOrder
					End If
					If InStr(1,LoadOrder,"sspifilt")>0 Then
						LoadOrder = Replace(LoadOrder,"sspifilt","")
						LoadOrder = Replace(LoadOrder,",,",",")
						LoadOrder = "sspifilt," & LoadOrder
					End If
					Filters.FilterLoadOrder = LoadOrder
					Filters.SetInfo

					'make filter
					Set Filter = Filters.Create("IIsFilter", FilterName)
					Filter.FilterPath = FilterPath & FilterDLLName
					Filter.FilterDescription = FilterDesc
					Filter.SetInfo

					'notify user
					MsgBox FilterName & " is succesfully installed on " & HostName & vbCRLF & vbCRLF & "You should review any settings of " & FilterName & " (by running config.exe in " & uncpath & ") and restart IIS on " & HostName & " to load the firewall!",,FilterName
				End If
			End If
		End If
	End If
End If