'
'uninstall.vbs
'script for removing WebKnight from an IIS server
'
Option Explicit
Dim HostName
Dim Filters
Dim Filter
Dim LoadOrder
Dim FilterName
Dim FilterPath
Dim FilterDLLName

'HostName = "LocalHost"				'uncomment this for unattended setup
FilterName = "WebKnight"
FilterDLLName = "WebKnight.dll"

'ask for hostname if we don't have one
If HostName = "" Then
	HostName = InputBox("Specify the IIS host from which you want to have " & FilterName & " uninstalled","Hostname required","LocalHost")
End If
If HostName <> "" Then 'user did not cancel?
	'get list of installed filters
	Set Filters = GetObject("IIS://" & HostName & "/W3SVC/Filters")
	LoadOrder = Filters.FilterLoadOrder
	If InStr(1,LoadOrder,FilterName)<1 Then
		MsgBox "Filter is not installed on " & HostName,,FilterName
	Else
		'get directory of installed filter
		Set Filter = GetObject("IIS://" & HostName & "/W3SVC/Filters/" & FilterName)
		FilterPath = Filter.FilterPath
		FilterPath = Left(FilterPath,Len(FilterPath)-Len(FilterDLLName))
		'remove trailing '\' (stupid DeleteFolder does not accept it)
		Do While Right(FilterPath,1)="\"
			FilterPath = Left(FilterPath,Len(FilterPath)-1)
		Loop
		
		'convert dir to unc path or leave it if it's local
		Dim uncpath
		If LCase(HostName)="localhost" Then
			uncpath = FilterPath
		Else
			uncpath = "\\" & HostName & "\" & Replace(FilterPath,":","$")
		End If
		
		'remove filter from list
		LoadOrder = Replace(LoadOrder,FilterName,"")
		LoadOrder = Replace(LoadOrder,",,",",")
		If Left(LoadOrder,1) = "," Then
			LoadOrder = Mid(LoadOrder,2)
		End If
		If Right(LoadOrder,1) = "," Then
			LoadOrder = Left(LoadOrder,Len(LoadOrder)-1)
		End If
		Filters.FilterLoadOrder = LoadOrder
		Filters.SetInfo

		'remove filter
		Filters.Delete "IIsFilter",FilterName

		'restart iis
		' TO DO

		'remove installed dir if yes
		If MsgBox("Do you want to completely remove the directory " & uncPath & " as well?",vbYesNo,FilterName)=vbYes Then
			Dim fso
			Set fso = CreateObject("Scripting.FileSystemObject")
			On Error Resume Next
			fso.DeleteFolder uncpath, True
			if Err Then
				MsgBox "There was an error deleting the files. You should do it manually, setup will continue" & vbCRLF & vbCRLF & "The specified error is: " & err.Number & ": " & err.Description,,FilterName
			End If
			On Error Goto 0
		End If	

		'notify user
		MsgBox FilterName & " was succesfully uninstalled.",,FilterName
	End If
End If

