/*
    AQTRONIX C++ Library
    Copyright 2005-2006 Parcifal Aertssen

    This file is part of AQTRONIX C++ Library.

    AQTRONIX C++ Library is free software; you can redistribute it
	and/or modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2 of
	the License, or (at your option) any later version.

    AQTRONIX C++ Library is distributed in the hope that it will be
	useful, but WITHOUT ANY WARRANTY; without even the implied warranty
    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with AQTRONIX C++ Library; if not, write to the Free
    Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
    MA  02111-1307  USA
*/
// ISAPIFirewall.h: interface for the CISAPIFirewall class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ISAPIFIREWALL_H__E3402E9C_2ACB_45FF_AC12_09963674CD50__INCLUDED_)
#define AFX_ISAPIFIREWALL_H__E3402E9C_2ACB_45FF_AC12_09963674CD50__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ISAPIFilter.h"
#include "HTTPFirewall.h"

class CISAPIFirewall : public CISAPIFilter, public CHTTPFirewall  
{
public:
	virtual bool CustomSendRawData(CHttpFilterContext *pfc, PHTTP_FILTER_RAW_DATA pRawData, CString& Response);
	virtual bool CustomHeaderScanning(CHttpFilterContext *pfc, PHTTP_FILTER_PREPROC_HEADERS pHeaders,CString& ip, CURL& RawUrl);
	bool ScanConnection(CHttpFilterContext *pfc, CString& ip);
	bool ScanHeaders(CHttpFilterContext* pfc, PHTTP_FILTER_PREPROC_HEADERS pHeaders);
	inline void LogRequestInfo(CHttpFilterContext* pfc);
	inline void LogClientInfoExtra(CHttpFilterContext* pfc);
	bool OnReadRawDataDebug(CHttpFilterContext* pCtxt,PHTTP_FILTER_RAW_DATA pRawData);
	void SetFilterVersion(PHTTP_FILTER_VERSION pVer);
	void LogClientInfo(CHttpFilterContext* pfc);
	void HackResponse(CHttpFilterContext* pfc, LPCTSTR ServerHeader = "CISAPIFirewall/1.0");
	bool ScanResponseStatus(CHttpFilterContext* pfc, LPCTSTR Status, bool& ResetFilterContext);

// Overrides
	// ClassWizard generated virtual function overrides
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//{{AFX_VIRTUAL(CISAPIFirewall)
	public:
	virtual DWORD OnReadRawData(CHttpFilterContext* pCtxt, PHTTP_FILTER_RAW_DATA pRawData, LPCTSTR ServerHeader);
	virtual DWORD OnPreprocHeaders(CHttpFilterContext* pfc, PHTTP_FILTER_PREPROC_HEADERS pHeaders,LPCTSTR SiteInstance, LPCTSTR ServerHeader);
	virtual DWORD OnAuthentication(CHttpFilterContext* pfc, PHTTP_FILTER_AUTHENT pAuthent, LPCTSTR SiteInstance, LPCTSTR ServerHeader);
	virtual DWORD OnUrlMap(CHttpFilterContext* pfc, PHTTP_FILTER_URL_MAP pUrlMap, LPCTSTR SiteInstance, LPCTSTR ServerHeader);
	virtual DWORD OnSendRawData(CHttpFilterContext* pfc, PHTTP_FILTER_RAW_DATA pRawData, LPCTSTR SiteInstance);
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CISAPIFirewall)
	//}}AFX_MSG

	CISAPIFirewall(CHTTPFirewallSettings& _Settings);
	virtual ~CISAPIFirewall();

};

#endif // !defined(AFX_ISAPIFIREWALL_H__E3402E9C_2ACB_45FF_AC12_09963674CD50__INCLUDED_)
