'
'regiis.vbs
'Script for adding WebKnight in the IIS metabase on localhost using current directory
'
Option Explicit

Dim HostName
Dim Filters
Dim Filter
Dim LoadOrder
Dim FilterName
Dim FilterPath
Dim FilterDLLName
Dim FilterDesc

FilterName = "WebKnight"
FilterDLLName = "WebKnight.dll"
FilterDesc = "Filter for securing IIS"

'uncomment the two lines below for unattended setup
HostName = "LocalHost"
FilterPath = Session.Property("WEBKNIGHTDIR")

If Left(FilterPath,1)="\" Then	'no UNC paths!
	MsgBox "UNC paths not allowed!",,FilterName
Else
	'add trailing slash if not there
	If Right(FilterPath,1)<>"\" And Right(FilterPath,1)<>"/" Then
		FilterPath = FilterPath & "\"
	End If

	'get list of filters on the host
	Set Filters = GetObject("IIS://" & HostName & "/W3SVC/Filters")
	LoadOrder = Filters.FilterLoadOrder

	If InStr(1,LoadOrder,FilterName)>0 Then	'filter already installed?
		MsgBox FilterName & " is already installed on " & Hostname,,FilterName
	Else
		'register filter in IIS metabase
		'set filter to be loaded first (high security)
		If LoadOrder <> "" Then
			LoadOrder = "," & LoadOrder
		End If
		LoadOrder = FilterName & LoadOrder
		If InStr(1,LoadOrder,"Compression")>0 Then
			LoadOrder = Replace(LoadOrder,"Compression","")
			LoadOrder = Replace(LoadOrder,",,",",")
			LoadOrder = "Compression," & LoadOrder
		End If
		If InStr(1,LoadOrder,"sspifilt")>0 Then
			LoadOrder = Replace(LoadOrder,"sspifilt","")
			LoadOrder = Replace(LoadOrder,",,",",")
			LoadOrder = "sspifilt," & LoadOrder
		End If
		Filters.FilterLoadOrder = LoadOrder
		Filters.SetInfo

		'make filter
		Set Filter = Filters.Create("IIsFilter", FilterName)
		Filter.FilterPath = FilterPath & FilterDLLName
		Filter.FilterDescription = FilterDesc
		Filter.SetInfo

		'notify user
		MsgBox FilterName & " is succesfully installed." & vbCRLF & vbCRLF & "You should review any settings of WebKnight (by running config.exe in " & FilterPath & ") and restart IIS on " & HostName & " to load the firewall!",,FilterName
	End If
End If
