/*
    AQTRONIX C++ Library
    Copyright 2005-2006 Parcifal Aertssen

    This file is part of AQTRONIX C++ Library.

    AQTRONIX C++ Library is free software; you can redistribute it
	and/or modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2 of
	the License, or (at your option) any later version.

    AQTRONIX C++ Library is distributed in the hope that it will be
	useful, but WITHOUT ANY WARRANTY; without even the implied warranty
    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with AQTRONIX C++ Library; if not, write to the Free
    Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
    MA  02111-1307  USA
*/
// ExploitScan.cpp: implementation of the CExploitScan class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ExploitScan.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

/* CHANGELOG
 *
 *	2005.07.14 Class created
 */
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CExploitScan::CExploitScan()
{

}

CExploitScan::~CExploitScan()
{

}

bool CExploitScan::ScanHighBitShellCode(const char* ScanString)
{
	for(unsigned int i=0;i<strlen(ScanString);i++){
		if((unsigned char)ScanString[i]>127){
			return true;
		}
	}
	return false;
}

bool CExploitScan::ScanHighBitShellCode(CString& ScanString)
{
	return ScanHighBitShellCode(ScanString.GetBuffer(1));
}

int CExploitScan::ScanSQLInjection(const CString &ScanString, const CStringList &SQLKeyWords)
{
	return CountKeywords(ScanString,SQLKeyWords);
}

bool CExploitScan::ScanParentPath(const CString& ScanString)
{
	if(ScanString.Find("..")==-1){
		return false;
	}else{
		return true;
	}
}

bool CExploitScan::ScanDirectoryTraversal(const CString& ScanString)
{
	if(ScanString.Find("../")!=-1 || ScanString.Find("..\\")!=-1 || ScanString.Find("/..")!=-1 || ScanString.Find("\\..")!=-1){
		return true;
	}else{
		return false;
	}
}

bool CExploitScan::ScanHexEncodingAbuse(const CString& ScanString)
{
	if(ScanString.Find("%00")!=-1 || ScanString.Find("%u0000")!=-1){
		return true;
	}else{
		return false;
	}
}

bool CExploitScan::ScanHexEncodingEmbedding(const CString& ScanString,const bool ConvertPlus)
{
	CString ScanDecodedString = CURL::URLEncodedToASCII(ScanString);
	return CanHexDecode(ScanDecodedString,ConvertPlus);
}

bool CExploitScan::CanHexDecode(const CString& ScanString, const bool ConvertPlus)
{
	if(ScanString!=CURL::URLEncodedToASCII(ScanString,ConvertPlus)){
		return true;
	}else{
		return false;
	}
}

CString CExploitScan::RemoveRFCComments(CString& RFCString)
{
	int count(0);
	CString ret("");
	TCHAR c;
	int length = RFCString.GetLength();
	if(length>0){
		for(int i=0; i<length; i++){
			c = RFCString.GetAt(i);
			switch (c){
			case '(':
				count++;
				break;
			case ')':
				count--;
				break;
			default:
				{
					if(count==0){
						ret += c;
					}
					break;
				}
			}
			if(count<0){	//not good, exit loop and return User Agent
				return RFCString;
			}
		}

		//if error in comments, return complete UserAgent
		if(count!=0){
			ret = RFCString;
		}
	}
	return ret;
}